MODULE Reverse_direkt EXPORTS Main;



(* Ausgabe des invertierten Wortes

   Autor    : Antje Nowack

   Umgebung : SRC-Modula-3 rel. 3.6, Windows NT 95

   Erstellt : 10.11.2000   Letzte Aenderung: 10.11.2000

*)



IMPORT SIO, Text;



(* Die folgende Funktion invertiert ein gegebenes Wort.

Sie arbeitet rekursiv. 

Zunaechst gibt es zwei Sonderfaelle: Das leere Wort und 

solche Woerter, die nur aus einem Zeichen bestehen. In 

beiden Fllen ist das invertierte Wort gleich dem 

urspruenglichen.

Sonst wird das erste Zeichen abgespalten, ddas restliche

Wort invertiert und das Zeichen an das invertierte 

Restwort angehaengt. *)



PROCEDURE Reverse_direkt(string: TEXT) : TEXT =

BEGIN

  IF Text.Empty (string) THEN 

    RETURN string;  

  ELSIF Text.Length(string) = 1 THEN

    RETURN string;

    ELSE RETURN Text.Cat(Reverse_direkt(Text.Sub(string, 1, Text.Length(string) - 1)), Text.FromChar(Text.GetChar(string, 0))); 

  END;

END Reverse_direkt;





BEGIN

  SIO.PutWord("Bitte geben Sie eine Zeichenfolge ein: ");

  SIO.PutWord (Reverse_direkt (SIO.GetLine ())); 

  SIO.Nl(); 

END Reverse_direkt.