MODULE GetraenkeAutomat EXPORTS Main;

IMPORT SIO;        (* Importiere Ein-/Ausgabeoperationen *)

IMPORT Assertion;  (* Operationen fuer Zusicherungen. *)
IMPORT Automat;    (* Objektmodul fuer den Getraenkeautomaten. *)

BEGIN
  (* Assertion.DisableAssertions(); *) (* Zum Vergleich! *)
  
  TRY 
    Automat.Auffuellen();
    Automat.Auffuellen();
    Automat.Auffuellen();
    Automat.Auffuellen();
    Automat.Auffuellen();

    SIO.PutLine("1. Automat mit 5 Getraenken aufgefuellt!");
    SIO.Nl();
  EXCEPT
    Assertion.Violated => SIO.PutLine("1. Auffuellen nicht moeglich!");
                          SIO.Nl();
  END;

  TRY 
    Automat.Auffuellen();
    SIO.PutLine("2. Automat mit weiterem Getraenk gefuellt!");
    SIO.Nl();
  EXCEPT
    Assertion.Violated => SIO.PutLine("2. Auffuellen nicht moeglich!");
                          SIO.Nl();
  END;

  TRY 
    Automat.Entnehmen();
    SIO.PutLine("3. Getraenk entnommen!");
    SIO.Nl();
  EXCEPT
    Assertion.Violated => SIO.PutLine("3. Entnehmen nicht moeglich!");
                          SIO.Nl();
  END;

  TRY 
    Automat.MuenzeEinwerfen();
    SIO.PutLine("4. Muenze eingeworfen!");
    SIO.Nl();
  EXCEPT
    Assertion.Violated => SIO.PutLine("4. Einwerfen nicht moeglich!");
  END;

  TRY 
    Automat.MuenzeEinwerfen();
    SIO.PutLine("5. Muenze eingeworfen!");
    SIO.Nl();
  EXCEPT
    Assertion.Violated => SIO.PutLine("5. Einwerfen nicht moeglich!");
                          SIO.Nl();
  END;

  TRY 
    Automat.Entnehmen();
    SIO.PutLine("6. Getraenk entnommen!");
    SIO.Nl();
  EXCEPT
    Assertion.Violated => SIO.PutLine("6. Entnehmen nicht moeglich!");
                          SIO.Nl();
  END;

  TRY 
    Automat.MuenzeEinwerfen();
    Automat.Entnehmen();
    Automat.MuenzeEinwerfen();
    Automat.Entnehmen();
    Automat.MuenzeEinwerfen();
    Automat.Entnehmen();
    Automat.MuenzeEinwerfen();
    Automat.Entnehmen();
    SIO.PutLine("7. Vier weitere Getraenke entnommen!");
    SIO.Nl();
  EXCEPT
    Assertion.Violated => SIO.PutLine("7. Fehler bei Entnahme vier weiterer Getraenke!");
                          SIO.Nl();
  END;

  TRY 
    Automat.MuenzeEinwerfen();
    Automat.Entnehmen();
    SIO.PutLine("8. Noch ein Getraenk entnommen!");
    SIO.Nl();
  EXCEPT
    Assertion.Violated => SIO.PutLine("8. Entnehmen nicht moeglich!");
                          SIO.Nl();
  END;

  TRY 
    Automat.GeldZurueck();
    SIO.PutLine("9. Geld zurueckbekommen!");
    SIO.Nl();
  EXCEPT
    Assertion.Violated => SIO.PutLine("9. Geld zurueck nicht moeglich!");
                          SIO.Nl();
  END;

  TRY 
    Automat.GeldZurueck();
    SIO.PutLine("10. Geld zurueckbekommen!");
    SIO.Nl();
  EXCEPT
    Assertion.Violated => SIO.PutLine("10. Geld zurueck nicht moeglich!");
                          SIO.Nl();
  END;

END GetraenkeAutomat.